Subject: Re: [pkix] [saag] Fwd: New Version Notification for draft-belyavskiy-certificate-limitation-policy-04.txt

From: Dmitry Belyavsky <[email-masked]>
Date: Sat, 7 Oct 2017 21:37:09 +0300

Dear Nicos,

Sorry for the delay with my response.

On Fri, Sep 22, 2017 at 11:06 AM, Nikos Mavrogiannopoulos <[email-masked]>
wrote:

> On Wed, Sep 20, 2017 at 3:21 PM, Dmitry Belyavsky <[email-masked]>
> wrote:
> > Dear Nikos
> >
> > On Wed, Sep 13, 2017 at 9:39 AM, Nikos Mavrogiannopoulos <
> [email-masked]>
> > wrote:
> >>
> >>
> >> 4. How do you handle extensions to this format?
> >>
> >> Overall, why not use X.509 extensions to store such additional
> >> constraints? We already (in the p11-kit trust store in Fedora/RHEL
> >> systems) use the notion of stapled extensions to limit certificates
> >> [0, 1] and seems quite a flexible approach. Have you considered that
> >> path?
> >>
> >> regards,
> >> Nikos
> >>
> >> [0].
> >> https://p11-glue.freedesktop.org/doc/storing-trust-policy/
> storing-trust-model.html
> >> [1].
> >> http://nmav.gnutls.org/2016/06/restricting-scope-of-ca-
> certificates.html
> > I've looked through the specification. It's OK for me, but I do not get
> > whether the attached extensions are crypto-protected.
>
> No, as these values are inserted by the administrator of the system,
> or us (the distributor of the software), we didn't feel we needed the
> introduction of additional PKI.
>

Well, the specification I suggest should allow applying CLPs issued by
major vendors (Mozilla etc).
For this purposes the CLPs should be validable => signed.

> How do you see the infrastructure on the
> draft-belyavskiy-certificate-limitation-policy? Who do you envision
> signing these structures? (I assume that distribution of data will be
> done by software distributors?)
>

I anticipate some ways to distribute CLPs.

1. Major vendor-issued CLPs are distributed either by vendors or by OS
vendors
(similar to, e.g., ca-certificates package in Debian). In this case we
should have
certificates to sign these CLPs distributed together with these bundles.

2. App-specific CLPs may include the key as a part of the application
bundle.
So CLP is distributed via normal app-distributing channel.

3. Locally created CLPs. This is the case more or less similar to the
p11-glue solution,
if I understand it correctly.

Various protocols, such as TAMP (RFC 5934) can be used for transport the
CLPs too.

>
> >> 4. How do you handle extensions to this format?
> >>
> > Simillary to CRL. Do you have ideas of the extensions?
>
> One problem with that is the fact that the existing CRL extensions are
> about extending attributes of the CRL, rather than adding/removing
> attributes to the certificate in question.
>

For this purposes I implied that the limitations are provided not by
extensions,
but as SEQUENCE of limitations related to the certificates.

Was I wrong in the ASN1 scheme in the current version of my draft?

> To bring the stapled extensions to your proposal, you'd need the
> Extensions and Extension fields from RFC5280, and
> add into limitedCertificates structure (I'll split it on the example
> below for clarity) the following field.
>
> LimitedCertificates  ::=   SEQUENCE OF LimitedCertificate
>
> LimitedCertificate ::= SEQUENCE {
>                 userCertificate         CertificateSerialNumber,
>                 certificateIssuer       Name,
>                 limitationDate          Time,
>                 limitationPropagation   Enum,
>                 fingerprint SEQUENCE {
>                     fingerprintAlgorithm AlgorithmIdentifier,
>                     fingerprintValue     OCTET STRING
>                                      } OPTIONAL,
>                 limitations          SEQUENCE,
>                                    } OPTIONAL,
>                                  };
>
>
>                 stapledExtensions Extensions; <----- NEW
> }
>

Sorry, I do not get the difference between the purposes of the field
'limitations'
and 'stapledExtensions'.

> Another difference between this profile and the p11-kit one, is that
> the extensions/revocation here is done on the certificate, while in
> p11-kit is done on the public key. Both approaches have pros and cons.
>

Sure.

>
> Another question. I also noticed the fingerprint field above. Is that
> to distinguish between same CAs with different keys? In that case
> using the SubjectPublicKeyIdentifier may be sufficient, and more
> natural as this is how certificates with matching DNs/serials are
> distinguished.
>

Do you mean Subject Key Identifier (RFC 5280, 4.2.1.2)?
Yes, I agree and I'll update the draft.

I introduced the fingerprint field to distinguish bogus certs from the
valid ones,
but I think the SKI will be OK for this purpose.

Thank you!

-- 
SY, Dmitry Belyavsky

---

From: Peter Bowen <[email-masked]>
Date: Sat, 7 Oct 2017 20:31:18 -0700

On Tue, Sep 12, 2017 at 5:59 AM, Dmitry Belyavsky via
dev-security-policy <[email-masked]> wrote:
> Here is the new version of the draft updated according to the discussion on
> mozilla-dev-security list.

Given that RFC 5914 already defines a TrustAnchorList and
TrustAnchorInfo object and that the Trust Anchor List object is
explicitly contemplated as being included in a signed CMS message,
would it not make more sense to start from 5914 and define new
extensions encode constraints not currently defined?

Thanks,
Peter

---

From: Carl Wallace <[email-masked]>
Date: Sun, 08 Oct 2017 10:16:00 -0400

Also, RFC 5937 defines how to process the constraints from the 5914
structure.

On 10/7/17, 11:31 PM, "pkix on behalf of Peter Bowen"
<[email-masked] on behalf of [email-masked]> wrote:

>_______________________________________________
>pkix mailing list
>[email-masked]
>https://www.ietf.org/mailman/listinfo/pkix

---

From: Nikos Mavrogiannopoulos <[email-masked]>
Date: Thu, 12 Oct 2017 14:03:23 +0200

On Sat, Oct 7, 2017 at 8:37 PM, Dmitry Belyavsky <[email-masked]> wrote:
>> > On Wed, Sep 13, 2017 at 9:39 AM, Nikos Mavrogiannopoulos
>> > <[email-masked]>
>> > wrote:
>> >>
>> >>
>> >> https://p11-glue.freedesktop.org/doc/storing-trust-policy/storing-trust-model.html
>> >> [1].
>> >>
>> >> http://nmav.gnutls.org/2016/06/restricting-scope-of-ca-certificates.html
> Well, the specification I suggest should allow applying CLPs issued by major
> vendors (Mozilla etc).

Hi,
 If mozilla or any other organization is willing to deploy such PKI,
that would be great. However for the majority of software, I'd expect
that such files are distributed using the same channel as software,
and thus using the same authentication mechanism for it rather than a
new PKI. For a software distributor to use that optional signing could
work.

> Was I wrong in the ASN1 scheme in the current version of my draft?

I do not think that the presented ASN.1 description is valid.
The "limitations          SEQUENCE," doesn't define anything in ASN.1
(i..e, it is a sequence of what?).

> Sorry, I do not get the difference between the purposes of the field

I cannot answer this as I cannot see the syntax of the limitations
field. I thought it was a field intended to spark discussion rather
than anything specific.

regards,
Nikos